<template>
    <div class="ht-button" @click="clickEvent"
         :class="colorProp + ' ' + isLoadingProp + ' ' + inverseProp" ref="htButton">
        <div :class="colorProp+'__loader ' + colorProp+'-loading'" v-if="loading"></div>
        <slot v-else :class="{'ht-button__inverse-text': inverse}"></slot>
    </div>
</template>

<script>
    export default {
        name: 'ht-button',
        emits: ['click'],
        props: {
            width: {
                type: String,
            },
            loading: {
                type: Boolean,
                default: false
            },
            inverse: {
                type: Boolean,
                default: false
            },
            variant: {
                type: String,
                default: 'main'
            }
        },
        data() {
            return {
                colorProp: '',
                loadingProp: '',
                isLoadingProp: '',
                inverseProp: ''
            };
        },
        mounted() {
            this.setClassName(this.variant);
        },
        methods: {
            setClassName(variant) {
                this.colorProp = ` ht-button-${variant}`;
                this.loadingProp = this.colorProp + '-loading';
                this.$refs.htButton.className += ` ${this.colorProp}`;
                if (this.inverse) {
                    this.inverseProp = ` ht-button-${variant}-inverse`;
                }else {
                    this.inverseProp = '';
                }
                if (this.loading) {
                    this.isLoadingProp = this.colorProp + '-isloading';
                }else {
                    this.isLoadingProp = '';
                }

            },
            clickEvent(event) {
                this.$emit('click', event);
            }
        },
        watch: {
            loading: function() {
                this.setClassName(this.variant);

            },
            variant: function (val) {
                this.setClassName(val);
            }
        }
    };
</script>

<style scoped>

</style>
